//****************************************************************************//
//                                                                            //
//   recola.h                                                                 //
//   is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2       //
//                                                                            //
//   Copyright (C) 2016,2017 Ansgar Denner, Jean-Nicolas Lang and             //
//                           Sandro Uccirati                                  //
//                                                                            //
//   RECOLA2 is licenced under the GNU GPL version 3,                         //
//   see COPYING for details.                                                 //
//                                                                            //
//****************************************************************************//

#ifndef RECOLA_H_
#define RECOLA_H_

#define ivoid void
typedef struct cconstruct{double dr,di;} dcomplex;

// module input_rcl
void __input_rcl_MOD_set_qcd_rescaling_rcl
       (const int*);
void __input_rcl_MOD_set_fermionloop_optimization_rcl
     (const int*);
void __input_rcl_MOD_set_helicity_optimization_rcl
     (const int*);
void __input_rcl_MOD_set_colour_optimization_rcl
     (const int*);
void __input_rcl_MOD_set_compute_a12_rcl
     (const int*);
void __input_rcl_MOD_set_masscut_rcl
     (const double*);
void __input_rcl_MOD_set_light_particle_rcl
     (const char*,long int);
void __input_rcl_MOD_unset_light_particle_rcl
     (const char*,long int);
void __input_rcl_MOD_use_dim_reg_soft_rcl
     ();
void __input_rcl_MOD_use_mass_reg_soft_rcl
     (const double*);
void __input_rcl_MOD_use_recola_base_rcl
     (const int*);
void __input_rcl_MOD_set_mass_reg_soft_rcl
     (const double*);
void __input_rcl_MOD_set_delta_uv_rcl
     (const double*);
void __input_rcl_MOD_get_delta_uv_rcl
     (const double*);
void __input_rcl_MOD_set_delta_ir_rcl
     (const double*, const double*);
void __input_rcl_MOD_get_delta_ir_rcl
     (const double*, const double*);
void __input_rcl_MOD_set_mu_uv_rcl
     (const double*);
void __input_rcl_MOD_get_mu_uv_rcl
     (const double*);
void __input_rcl_MOD_set_mu_ir_rcl
     (const double*);
void __input_rcl_MOD_get_mu_ir_rcl
     (const double*);
void __input_rcl_MOD_set_mu_ms_rcl
     (const double*);
void __input_rcl_MOD_get_mu_ms_rcl
     (const double*);
void __input_rcl_MOD_get_renormalization_scale_rcl
     (double*);
void __input_rcl_MOD_get_flavour_scheme_rcl
     (int*);
void __input_rcl_MOD_set_complex_mass_scheme_rcl
     ();
void __input_rcl_MOD_set_on_shell_scheme_rcl
     ();
void __input_rcl_MOD_set_momenta_correction_rcl
     (const int*);
void __input_rcl_MOD_set_print_level_amplitude_rcl
     (const int*);
void __input_rcl_MOD_set_print_level_squared_amplitude_rcl
     (const int*);
void __input_rcl_MOD_set_print_level_correlations_rcl
     (const int*);
void __input_rcl_MOD_set_print_level_parameters_rcl
     (const int*);
void __input_rcl_MOD_set_draw_level_branches_rcl
     (const int*);
void __input_rcl_MOD_set_print_level_ram_rcl
     (const int*);
void __input_rcl_MOD_scale_coupling3_rcl
     (const dcomplex*,const char*,const char*, const char*,
      long int,long int,long int);
void __input_rcl_MOD_scale_coupling4_rcl
     (const dcomplex*, const char*, const char*, const char*,const char*,
      long int,long int,long int,long int);
void __input_rcl_MOD_switchoff_coupling3_rcl
     (const char*,const char*,const char*,long int,long int,long int);
void __input_rcl_MOD_switchoff_coupling4_rcl
     (const char*,const char*,const char*,const char*,
      long int,long int,long int,long int);
void __input_rcl_MOD_switchon_resonant_selfenergies_rcl
     ();
void __input_rcl_MOD_switchoff_resonant_selfenergies_rcl
     ();
void __input_rcl_MOD_set_dynamic_settings_rcl
     (const int*);
void __input_rcl_MOD_set_ifail_rcl
     (const int*);
void __input_rcl_MOD_get_ifail_rcl
     (int*);
void __input_rcl_MOD_set_iwarn_rcl
     (const int*);
void __input_rcl_MOD_get_iwarn_rcl
     (int*);
void __input_rcl_MOD_set_collier_output_dir_rcl
     (const char*,long int);
void __input_rcl_MOD_set_output_file_rcl
     (const char*,long int);
void __input_rcl_MOD_set_log_mem_rcl
     (const int*);
void __input_rcl_MOD_set_init_collier_rcl
     (const int*);
void __input_rcl_MOD_set_parameter_rcl
     (const char*, dcomplex*, long int);
void __input_rcl_MOD_get_parameter_rcl
     (const char*, dcomplex*, long int);
void __input_rcl_MOD_set_renoscheme_rcl
     (const char*, const char*, long int, long int);
// get_renoscheme_rcl -> wrapper
void __input_rcl_MOD_set_resonant_particle_rcl
     (const char*,long int);
void __input_rcl_MOD_reset_vertices_rcl
     ();
void __input_rcl_MOD_reset_couplings_rcl
     ();
void __input_rcl_MOD_reset_ctcouplings_rcl
     ();
void __input_rcl_MOD_print_collier_statistics_rcl
     ();

// additional stuff, only used in combination with rept1l
void __input_rcl_MOD_set_compute_selfenergy_rcl
     (int*);
void __input_rcl_MOD_set_compute_selfenergy_offshell_rcl
     (int*);
void __input_rcl_MOD_set_compute_tadpole_rcl
     (int*);
void __input_rcl_MOD_set_lp_rcl
     (int*, int*);
void __input_rcl_MOD_set_form_rcl
     (int*);
void __input_rcl_MOD_set_all_couplings_active_rcl
     (int*);
void __input_rcl_MOD_set_all_tree_couplings_active_rcl
     (int*);
void __input_rcl_MOD_set_all_loop_couplings_active_rcl
     (int*);
void __input_rcl_MOD_set_all_ct_couplings_active_rcl
     (int*);
void __input_rcl_MOD_set_all_r2_couplings_active_rcl
     (int*);
void __input_rcl_MOD_set_complex_mass_form_rcl
     (int*);
void __input_rcl_MOD_set_vertex_functions_rcl
     (int*);
void __input_rcl_MOD_disable_particle_ordering_rcl
     (int*);
void __input_rcl_MOD_set_masscut_form_rcl
     (int*);
void __input_rcl_MOD_set_cutparticle_rcl
     (const char*, long int);
void __input_rcl_MOD_unset_cutparticle_rcl
     ();
void __input_rcl_MOD_set_print_recola_logo_rcl
     (int*);

// module recola1_interface_rcl
void __recola1_interface_rcl_MOD_set_pole_mass_w_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_onshell_mass_w_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_z_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_onshell_mass_z_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_h_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_top_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_bottom_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_charm_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_strange_rcl
     (const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_up_rcl
     (const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_down_rcl
     (const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_tau_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_muon_rcl
     (const double*,const double*);
void __recola1_interface_rcl_MOD_set_pole_mass_electron_rcl
     (const double*);
void __recola1_interface_rcl_MOD_set_light_top_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_top_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_bottom_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_bottom_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_charm_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_charm_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_strange_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_strange_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_up_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_up_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_down_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_down_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_tau_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_tau_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_muon_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_muon_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_electron_rcl
     ();
void __recola1_interface_rcl_MOD_unset_light_electron_rcl
     ();
void __recola1_interface_rcl_MOD_set_light_fermions_rcl
     (const double*);
// use_gfermi_scheme_rcl -> wrapper
void __recola1_interface_rcl_MOD_use_alpha0_scheme_rcl
     (const double*);
void __recola1_interface_rcl_MOD_use_alphaz_scheme_rcl
     (const double*);
void __recola1_interface_rcl_MOD_get_alpha_rcl
     (double*);
void __recola1_interface_rcl_MOD_set_alphas_rcl
     (const double*,const double*,const int*);
void __recola1_interface_rcl_MOD_get_alphas_rcl
     (double*);
void __recola1_interface_rcl_MOD_set_alphas_masses_rcl
     (const double*,const double*,const double*,
      const double*,const double*,const double*);
void __recola1_interface_rcl_MOD_compute_running_alphas_rcl
     (const double*, const int*, const int*);
void __recola1_interface_rcl_MOD_select_all_gs_powers_bornampl_rcl
     (const int*);
void __recola1_interface_rcl_MOD_unselect_all_gs_powers_bornampl_rcl
     (const int*);
void __recola1_interface_rcl_MOD_select_gs_power_bornampl_rcl
     (const int*, const int*);
void __recola1_interface_rcl_MOD_unselect_gs_power_bornampl_rcl
     (const int*, const int*);
void __recola1_interface_rcl_MOD_select_all_gs_powers_loopampl_rcl
     (const int*);
void __recola1_interface_rcl_MOD_unselect_all_gs_powers_loopampl_rcl
     (const int*);
void __recola1_interface_rcl_MOD_select_gs_power_loopampl_rcl
     (const int*, const int*);
void __recola1_interface_rcl_MOD_unselect_gs_power_loopampl_rcl
     (const int*, const int*);
void __recola1_interface_rcl_MOD_get_colour_correlation_r1_rcl
     (const int*, const int*, const int*, const int*, double*);
void __recola1_interface_rcl_MOD_get_spin_colour_correlation_r1_rcl
     (const int*, const int*, const int*, const int*, double*);
void __recola1_interface_rcl_MOD_get_spin_correlation_r1_rcl
     (const int*, const int*, double*);
// set_gs_power_rcl -> wrapper
// get_amplitude_r1_rcl -> wrapper
/* get_*_amplitude_r1_rcl ?:  <24-07-17, Jean-Nicolas Lang> */
/* get_*_correlation_r1_rcl ?:  <24-07-17, Jean-Nicolas Lang> */

// module process_definition_rcl
void __process_definition_rcl_MOD_define_process_rcl
     (const int*,const char*,const char*,long int,long int);
void __process_definition_rcl_MOD_select_power_bornampl_rcl
     (const int*,const char*, const int*,long int);
void __process_definition_rcl_MOD_unselect_power_bornampl_rcl
     (const int*,const char*,const int*,long int);
void __process_definition_rcl_MOD_select_all_powers_bornampl_rcl
     (const int*);
void __process_definition_rcl_MOD_unselect_all_powers_bornampl_rcl
     (const int*);
void __process_definition_rcl_MOD_select_power_loopampl_rcl
     (const int*,const char*,const int*,long int);
void __process_definition_rcl_MOD_unselect_power_loopampl_rcl
     (const int*,const char*,const int*,long int);
void __process_definition_rcl_MOD_select_all_powers_loopampl_rcl
     (const int*);
void __process_definition_rcl_MOD_unselect_all_powers_loopampl_rcl
     (const int*);
void __process_definition_rcl_MOD_split_collier_cache_rcl
     (const int*,const int*);

// module process_generation_rcl
void __process_generation_rcl_MOD_generate_processes_rcl
     ();

// module process_computation_rcl
void __process_computation_rcl_MOD_set_resonant_squared_momentum_rcl
     (const int*, const int*, const double*);
void __process_computation_rcl_MOD_rescale_process_rcl
     (const int*,const char*,double*,long int);
void __process_computation_rcl_MOD_rescale_colour_correlation_rcl
     (const int*,const int*,const int*,double*);
void __process_computation_rcl_MOD_rescale_all_colour_correlations_rcl
     (const int*);
void __process_computation_rcl_MOD_rescale_spin_colour_correlation_rcl
  (const int*, const int*, const int*,const dcomplex[4], double*);
void __process_computation_rcl_MOD_rescale_spin_correlation_rcl
  (const int*, const int*, const dcomplex[4], double*);
void __process_computation_rcl_MOD_set_tis_required_accuracy_rcl
     (const double*);
void __process_computation_rcl_MOD_get_tis_required_accuracy_rcl
     (double*);
void __process_computation_rcl_MOD_set_tis_critical_accuracy_rcl
     (const double*);
void __process_computation_rcl_MOD_get_tis_critical_accuracy_rcl
     (double*);
void __process_computation_rcl_MOD_get_tis_accuracy_flag_rcl
     (int*);

/* get_colour/helicity_configs:  <24-07-17, Jean-Nicolas Lang> */

// module wrapper_rcl
void __wrapper_rcl_MOD_set_alphas_masses_nowidtharg_rcl
     (const double*,const double*,const double*);
void __wrapper_rcl_MOD_use_gfermi_scheme_noarg_rcl
     ();
void __wrapper_rcl_MOD_use_gfermi_scheme_and_set_alpha_rcl
     (const double*);
void __wrapper_rcl_MOD_use_gfermi_scheme_and_set_gfermi_rcl
     (const double*);
void __wrapper_rcl_MOD_use_alpha0_scheme_noarg_rcl
     ();
void __wrapper_rcl_MOD_use_alphaz_scheme_noarg_rcl
     ();
void __wrapper_rcl_MOD_wrapper_set_gs_power_rcl
     (const int*,int[][2],const int*);
void __wrapper_rcl_MOD_wrapper_set_outgoing_momenta_rcl
     (const int*, double[][4], double[][4], const int*);
void __wrapper_rcl_MOD_wrapper_compute_process_rcl
     (const int*,double[][4],const int*, 
      const char*,double*,int*,long int);
void __wrapper_rcl_MOD_wrapper_get_amplitude_r1_rcl
     (const int*, const int*, const char*, const int[], const int[], 
      const int*, dcomplex*, long int);
void __wrapper_rcl_MOD_wrapper_get_amplitude_general_rcl
     (const int*, const int[], const int*, const char*, const int[],
      const int[], const int*, dcomplex*, long int);
void __wrapper_rcl_MOD_wrapper_get_squared_amplitude_r1_rcl
     (const int *, const int*, 
      const char*, double*, long int); 
void __wrapper_rcl_MOD_wrapper_get_squared_amplitude_general_rcl
     (const int *, const int[], const int*,
      const char*, double*, long int); 
void __wrapper_rcl_MOD_wrapper_get_polarized_squared_amplitude_r1_rcl
     (const int*, const int*, const char*, const int[], 
      const int*, double*, long int);
void __wrapper_rcl_MOD_wrapper_get_polarized_squared_amplitude_general_rcl
     (const int*, const int[], const int*, const char*, const int[], 
      const int*, double*, long int);
void __wrapper_rcl_MOD_wrapper_compute_colour_correlation_rcl
     (const int*, double[][4], const int*, const int*, const int*,
      double*, int*);
void __wrapper_rcl_MOD_wrapper_compute_all_colour_correlations_rcl
     (const int*, double[][4], const int*, int*);
void __wrapper_rcl_MOD_wrapper_get_colour_correlation_general_rcl
     (const int*, const int[], const int*, const int*,const int*, double*);
void __wrapper_rcl_MOD_wrapper_compute_spin_colour_correlation_rcl
     (const int*, double [][4], const int*, const int*, const int*,
      const dcomplex[4], double*, int*);
void __wrapper_rcl_MOD_wrapper_get_spin_colour_correlation_general_rcl
     (const int*, const int[], const int*, const int*,const int*, double*);
void __wrapper_rcl_MOD_wrapper_compute_spin_correlation_rcl
     (const int*, double[][4], const int*, const int*, 
      const dcomplex[4], double*, int*);
void __wrapper_rcl_MOD_wrapper_get_spin_correlation_general_rcl
     (const int*, const int[], const int*, double*);
void __wrapper_rcl_MOD_get_legs_rcl
     (const int*, int*);
void __wrapper_rcl_MOD_get_n_orders_rcl
     (int*);
void __wrapper_rcl_MOD_wrapper_get_momenta_rcl
     (const int*, double [][4], const int*);
void __wrapper_rcl_MOD_wrapper_get_recola_version_rcl
     (char*,int*,long int);
void __wrapper_rcl_MOD_wrapper_get_modelname_rcl
     (char*,int*,long int);
void __wrapper_rcl_MOD_wrapper_get_modelgauge_rcl
     (char*,int*,long int);
void __wrapper_rcl_MOD_wrapper_get_driver_timestamp_rcl
     (char*,int*,long int);
void __wrapper_rcl_MOD_wrapper_get_renoscheme_rcl
     (const char[],char[], int*,long int);

  // module extended_higgs_interface_rcl
void __extended_higgs_interface_rcl_MOD_set_z2_thdm_yukawa_type_rcl
     (const int*);
void __extended_higgs_interface_rcl_MOD_set_pole_mass_hl_rcl
     (const double*,const double*);
void __extended_higgs_interface_rcl_MOD_set_pole_mass_hh_rcl
     (const double*,const double*);
void __extended_higgs_interface_rcl_MOD_set_pole_mass_hl_hh_rcl
     (const double*,const double*,const double*,const double*);
void __extended_higgs_interface_rcl_MOD_set_pole_mass_ha_rcl
     (const double*,const double*);
void __extended_higgs_interface_rcl_MOD_set_pole_mass_hc_rcl
     (const double*,const double*);
void __extended_higgs_interface_rcl_MOD_set_tb_cab_rcl
     (const double*,const double*);
void __extended_higgs_interface_rcl_MOD_use_mixing_alpha_msbar_scheme_rcl
     (const char*,long int);
void __extended_higgs_interface_rcl_MOD_use_mixing_alpha_onshell_scheme_rcl
     (const char*,long int);
void __extended_higgs_interface_rcl_MOD_use_mixing_beta_onshell_scheme_rcl
     (const char*,long int);
void __extended_higgs_interface_rcl_MOD_use_mixing_beta_msbar_scheme_rcl
     (const char*,long int);
void __extended_higgs_interface_rcl_MOD_set_msb_rcl
     (const double*);
void __extended_higgs_interface_rcl_MOD_use_msb_msbar_scheme_rcl
     (const char*,long int);
void __extended_higgs_interface_rcl_MOD_set_sa_rcl
     (const double*);
void __extended_higgs_interface_rcl_MOD_set_tb_rcl
     (const double*);
void __extended_higgs_interface_rcl_MOD_use_tb_msbar_scheme_rcl
     ();
void __extended_higgs_interface_rcl_MOD_use_tb_ts_msbar_scheme_rcl
     ();

// module statistics_rcl
void __statistics_rcl_MOD_print_generation_statistics_rcl
     ();
void __statistics_rcl_MOD_print_ti_statistics_rcl
     (const int*,const int*);
void __statistics_rcl_MOD_print_tc_statistics_rcl
     (const int*,const int*);

// module reset_rcl
void __reset_rcl_MOD_reset_recola_rcl
     ();

/**********************
*  module input_rcl  *
**********************/

ivoid set_qcd_rescaling_rcl
      (const int value)
{
  __input_rcl_MOD_set_qcd_rescaling_rcl(&value);
}
ivoid set_fermionloop_optimization_rcl
      (const int value)
{
  __input_rcl_MOD_set_fermionloop_optimization_rcl(&value);
}
ivoid set_helicity_optimization_rcl
      (const int value)
{
  __input_rcl_MOD_set_helicity_optimization_rcl(&value);
}
ivoid set_colour_optimization_rcl
      (const int value)
{
  __input_rcl_MOD_set_colour_optimization_rcl(&value);
}
ivoid set_compute_A12_rcl
      (const int value)
{
  __input_rcl_MOD_set_compute_a12_rcl(&value);
}
ivoid set_masscut_rcl
      (double value)
{
  __input_rcl_MOD_set_masscut_rcl(&value);
}
ivoid set_light_particle_rcl
      (const char* pa)
{
  __input_rcl_MOD_set_light_particle_rcl(pa,strlen(pa));
}
ivoid unset_light_particle_rcl
      (const char* pa)
{
  __input_rcl_MOD_unset_light_particle_rcl(pa,strlen(pa));
}
ivoid use_dim_reg_soft_rcl()
{
  __input_rcl_MOD_use_dim_reg_soft_rcl();
}
ivoid use_mass_reg_soft_rcl
      (const double m)
{
  __input_rcl_MOD_use_mass_reg_soft_rcl(&m);
}
ivoid use_recola_base_rcl
      (const int rb)
{
  __input_rcl_MOD_use_recola_base_rcl(&rb);
}
ivoid set_mass_reg_soft_rcl
      (const double m)
{
  __input_rcl_MOD_set_mass_reg_soft_rcl(&m);
}
ivoid set_delta_uv_rcl
      (const double d)
{
  __input_rcl_MOD_set_delta_uv_rcl(&d);
}
ivoid get_delta_uv_rcl
      (double* d)
{
  __input_rcl_MOD_get_delta_uv_rcl(d);
}
ivoid set_delta_ir_rcl
      (const double d, const double d2)
{
  __input_rcl_MOD_set_delta_ir_rcl(&d, &d2);
}
ivoid get_delta_ir_rcl
      (double* d, double* d2)
{
  __input_rcl_MOD_get_delta_ir_rcl(d, d2);
}
ivoid set_mu_uv_rcl
      (const double mu_uv)
{
  __input_rcl_MOD_set_mu_uv_rcl(&mu_uv);
}
ivoid get_mu_uv_rcl
      (double* mu_uv)
{
  __input_rcl_MOD_get_mu_uv_rcl(mu_uv);
}
ivoid set_mu_ir_rcl
      (const double mu_ir)
{
  __input_rcl_MOD_set_mu_ir_rcl(&mu_ir);
}
ivoid get_mu_ir_rcl
      (double* mu_ir)
{
  __input_rcl_MOD_get_mu_ir_rcl(mu_ir);
}
ivoid set_mu_ms_rcl
      (const double mu_ms)
{
  __input_rcl_MOD_set_mu_ms_rcl(&mu_ms);
}
ivoid get_mu_ms_rcl
      (double* mu_ms)
{
  __input_rcl_MOD_set_mu_ms_rcl(mu_ms);
}
ivoid get_renormalization_scale_rcl
      (double* mu)
{
  __input_rcl_MOD_get_renormalization_scale_rcl(mu);
}
ivoid get_flavour_scheme_rcl
      (int *nf)
{
  __input_rcl_MOD_get_flavour_scheme_rcl(nf);
}
ivoid set_complex_mass_scheme_rcl()
{
  __input_rcl_MOD_set_complex_mass_scheme_rcl();
}
ivoid set_on_shell_scheme_rcl()
{
  __input_rcl_MOD_set_on_shell_scheme_rcl();
}
ivoid set_momenta_correction_rcl
      (const int value)
{
  __input_rcl_MOD_set_momenta_correction_rcl(&value);
}
ivoid set_print_level_amplitude_rcl
     (const int n)
{
  __input_rcl_MOD_set_print_level_amplitude_rcl(&n);
}
ivoid set_print_level_squared_amplitude_rcl
     (const int n)
{
  __input_rcl_MOD_set_print_level_squared_amplitude_rcl(&n);
}
ivoid set_print_level_correlations_rcl
      (const int n)
{
  __input_rcl_MOD_set_print_level_correlations_rcl(&n);
}
ivoid set_print_level_parameters_rcl
            (const int n)
{
  __input_rcl_MOD_set_print_level_parameters_rcl(&n);
}
ivoid set_draw_level_branches_rcl
      (const int n)
{
  __input_rcl_MOD_set_draw_level_branches_rcl(&n);
}
ivoid set_print_level_RAM_rcl
      (const int n)
{
  __input_rcl_MOD_set_print_level_ram_rcl(&n);
}
ivoid scale_coupling3_rcl
      (const dcomplex fac, 
       const char* pa1,
       const char* pa2, 
       const char* pa3)
{
   __input_rcl_MOD_scale_coupling3_rcl(&fac,
                                       pa1,
                                       pa2,
                                       pa3,
                                       strlen(pa1),
                                       strlen(pa2),
                                       strlen(pa3));
}
ivoid scale_coupling4_rcl
      (const dcomplex fac, 
       const char* pa1,
       const char* pa2, 
       const char* pa3,
       const char* pa4)
{
   __input_rcl_MOD_scale_coupling4_rcl(&fac,
                                       pa1,
                                       pa2,
                                       pa3,
                                       pa4,
                                       strlen(pa1),
                                       strlen(pa2),
                                       strlen(pa3),
                                       strlen(pa4));
}
ivoid switchoff_coupling3_rcl
      (const char* pa1,
       const char* pa2,
       const char* pa3)
{
  __input_rcl_MOD_switchoff_coupling3_rcl(pa1,
                                          pa2,
                                          pa3,
                                          strlen(pa1),
                                          strlen(pa2),
                                          strlen(pa3));
}
ivoid switchoff_coupling4_rcl
      (const char* pa1,
       const char* pa2,
       const char* pa3,
       const char* pa4)
{
  __input_rcl_MOD_switchoff_coupling4_rcl(pa1,
                                          pa2,
                                          pa3,
                                          pa4,
                                          strlen(pa1),
                                          strlen(pa2),
                                          strlen(pa3),
                                          strlen(pa4));
}
ivoid switchon_resonant_selfenergies_rcl()
{
  __input_rcl_MOD_switchon_resonant_selfenergies_rcl();
}
ivoid switchoff_resonant_selfenergies_rcl()
{
  __input_rcl_MOD_switchoff_resonant_selfenergies_rcl();
}
ivoid set_dynamic_settings_rcl
      (const int n)
{
  __input_rcl_MOD_set_dynamic_settings_rcl(&n);
}
ivoid set_ifail_rcl
      (const int i)
{
   __input_rcl_MOD_set_ifail_rcl(&i);
}
ivoid get_ifail_rcl
      (int *i)
{
   __input_rcl_MOD_get_ifail_rcl(i);
}
ivoid set_iwarn_rcl
      (const int i)
{
   __input_rcl_MOD_set_iwarn_rcl(&i);
}
ivoid get_iwarn_rcl
      (int *i)
{
   __input_rcl_MOD_get_iwarn_rcl(i);
}
ivoid set_collier_output_dir_rcl
      (const char* x)
{
  __input_rcl_MOD_set_collier_output_dir_rcl(x,strlen(x));
}
ivoid set_output_file_rcl
      (const char* x)
{
  __input_rcl_MOD_set_output_file_rcl(x,strlen(x));
}
ivoid set_log_mem_rcl
      (const int value)
{
  __input_rcl_MOD_set_log_mem_rcl(&value);
}
ivoid set_init_collier_rcl
      (int value)
{
  __input_rcl_MOD_set_init_collier_rcl(&value);
}
ivoid set_parameter_rcl
      (const char* pname,
       dcomplex pvalue)
{
  __input_rcl_MOD_set_parameter_rcl(pname,
                                    &pvalue,
                                    strlen(pname));
}
ivoid get_parameter_rcl
      (const char* pname, 
       dcomplex* pvalue)
{
  __input_rcl_MOD_get_parameter_rcl(pname, 
                                    pvalue,
                                    strlen(pname));
}
ivoid set_renoscheme_rcl
      (const char* renovar, const char* renoscheme){
  __input_rcl_MOD_set_renoscheme_rcl(renovar,
                                     renoscheme,
                                     strlen(renovar),
                                     strlen(renoscheme));
}
ivoid set_resonant_particle_rcl
      (const char* p)
{
  __input_rcl_MOD_set_resonant_particle_rcl(p, strlen(p));
}
ivoid reset_vertices_rcl()
{
  __input_rcl_MOD_reset_vertices_rcl();
}
ivoid reset_couplings_rcl()
{
  __input_rcl_MOD_reset_couplings_rcl();
}
ivoid reset_ctcouplings_rcl()
{
  __input_rcl_MOD_reset_ctcouplings_rcl();
}
ivoid print_collier_statistics_rcl()
{
  __input_rcl_MOD_print_collier_statistics_rcl();
}


/**********************************************
*  module input_rcl, additionals for rept1l  *
**********************************************/
ivoid set_compute_selfenergy_rcl
      (int value)
{
  __input_rcl_MOD_set_compute_selfenergy_rcl(&value);
}
ivoid set_compute_selfenergy_offshell_rcl
      (int value)
{
  __input_rcl_MOD_set_compute_selfenergy_offshell_rcl(&value);
}
ivoid set_compute_tadpole_rcl
      (int value)
{
  __input_rcl_MOD_set_compute_tadpole_rcl(&value);
}
ivoid set_lp_rcl
      (int lp_order, int value)
{
  __input_rcl_MOD_set_lp_rcl(&lp_order, &value);
}
ivoid set_form_rcl
      (int value)
{
  __input_rcl_MOD_set_form_rcl(&value);
}
ivoid set_all_couplings_active_rcl
      (int value)
{
  __input_rcl_MOD_set_all_couplings_active_rcl(&value);
}
ivoid set_all_tree_couplings_active_rcl
      (int value)
{
  __input_rcl_MOD_set_all_tree_couplings_active_rcl(&value);
}
ivoid set_all_loop_couplings_active_rcl
      (int value)
{
  __input_rcl_MOD_set_all_loop_couplings_active_rcl(&value);
}
ivoid set_all_ct_couplings_active_rcl 
      (int value)
{
  __input_rcl_MOD_set_all_ct_couplings_active_rcl(&value);
}
ivoid set_all_r2_couplings_active_rcl
      (int value)
{
  __input_rcl_MOD_set_all_r2_couplings_active_rcl(&value);
}
ivoid set_complex_mass_form_rcl
      (int value)
{
  __input_rcl_MOD_set_complex_mass_form_rcl(&value);
}
ivoid set_vertex_functions_rcl
      (int value)
{
  __input_rcl_MOD_set_vertex_functions_rcl(&value);
}
ivoid disable_particle_ordering_rcl
      (int value)
{
  __input_rcl_MOD_disable_particle_ordering_rcl(&value);
}
ivoid set_masscut_form_rcl
      (int value)
{
  __input_rcl_MOD_set_masscut_form_rcl(&value);
}
ivoid set_cutparticle_rcl
      (const char* pname)
{
  __input_rcl_MOD_set_cutparticle_rcl(pname, strlen(pname));
}
ivoid unset_cutparticle_rcl()
{
  __input_rcl_MOD_unset_cutparticle_rcl();
}
ivoid set_print_recola_logo_rcl
      (int value)
{
  __input_rcl_MOD_set_print_recola_logo_rcl(&value);
}

/**********************************
*  module recola1_interface_rcl  *
**********************************/

ivoid set_pole_mass_w_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_w_rcl(&m,&g);
}
ivoid set_onshell_mass_w_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_onshell_mass_w_rcl(&m,&g);
}
ivoid set_pole_mass_z_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_z_rcl(&m,&g);
}
ivoid set_onshell_mass_z_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_onshell_mass_z_rcl(&m,&g);
}
ivoid set_pole_mass_h_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_h_rcl(&m,&g);
}
ivoid set_pole_mass_top_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_top_rcl(&m,&g);
}
ivoid set_pole_mass_bottom_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_bottom_rcl(&m,&g);
}
ivoid set_pole_mass_charm_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_charm_rcl(&m,&g);
}
ivoid set_pole_mass_strange_rcl
      (const double m)
{
  __recola1_interface_rcl_MOD_set_pole_mass_strange_rcl(&m);
}
ivoid set_pole_mass_up_rcl
      (const double m)
{
  __recola1_interface_rcl_MOD_set_pole_mass_up_rcl(&m);
}
ivoid set_pole_mass_down_rcl
      (const double m)
{
  __recola1_interface_rcl_MOD_set_pole_mass_down_rcl(&m);
}
ivoid set_pole_mass_tau_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_tau_rcl(&m,&g);
}
ivoid set_pole_mass_muon_rcl
      (const double m, const double g)
{
  __recola1_interface_rcl_MOD_set_pole_mass_muon_rcl(&m,&g);
}
ivoid set_pole_mass_electron_rcl
      (const double m)
{
  __recola1_interface_rcl_MOD_set_pole_mass_electron_rcl(&m);
}
ivoid set_light_top_rcl()
{
  __recola1_interface_rcl_MOD_set_light_top_rcl();
}
ivoid unset_light_top_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_top_rcl();
}
ivoid set_light_bottom_rcl()
{
  __recola1_interface_rcl_MOD_set_light_bottom_rcl();
}
ivoid unset_light_bottom_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_bottom_rcl();
}
ivoid set_light_charm_rcl()
{
  __recola1_interface_rcl_MOD_set_light_charm_rcl();
}
ivoid unset_light_charm_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_charm_rcl();
}
ivoid set_light_strange_rcl()
{
  __recola1_interface_rcl_MOD_set_light_strange_rcl();
}
ivoid unset_light_strange_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_strange_rcl();
}
ivoid set_light_up_rcl()
{
  __recola1_interface_rcl_MOD_set_light_up_rcl();
}
ivoid unset_light_up_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_up_rcl();
}
ivoid set_light_down_rcl()
{
  __recola1_interface_rcl_MOD_set_light_down_rcl();
}
ivoid unset_light_down_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_down_rcl();
}
ivoid set_light_tau_rcl()
{
  __recola1_interface_rcl_MOD_set_light_tau_rcl();
}
ivoid unset_light_tau_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_tau_rcl();
}
ivoid set_light_muon_rcl()
{
  __recola1_interface_rcl_MOD_set_light_muon_rcl();
}
ivoid unset_light_muon_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_muon_rcl();
}
ivoid set_light_electron_rcl()
{
  __recola1_interface_rcl_MOD_set_light_electron_rcl();
}
ivoid unset_light_electron_rcl()
{
  __recola1_interface_rcl_MOD_unset_light_electron_rcl();
}
ivoid set_light_fermions_rcl
      (const double m)
{
  __recola1_interface_rcl_MOD_set_light_fermions_rcl(&m);
}
ivoid use_alpha0_scheme_and_set_alpha_rcl
      (const double a)
{
  __recola1_interface_rcl_MOD_use_alpha0_scheme_rcl(&a);
}
ivoid use_alphaz_scheme_and_set_alpha_rcl
      (const double a)
{
  __recola1_interface_rcl_MOD_use_alphaz_scheme_rcl(&a);
}
ivoid get_alpha_rcl
      (double* a)
{
  __recola1_interface_rcl_MOD_get_alpha_rcl(a);
}
ivoid set_alphas_rcl
      (double* aS, double* scaleQCD, int* nflavour)
{
  __recola1_interface_rcl_MOD_set_alphas_rcl(aS, scaleQCD, nflavour);
}
ivoid get_alphas_rcl
      (double* a)
{
  __recola1_interface_rcl_MOD_get_alphas_rcl(a);
}
ivoid set_alphas_masses_rcl
      (const double mc, const double mb, const double mt,
       const double wc, const double wb, const double wt)
{
  __recola1_interface_rcl_MOD_set_alphas_masses_rcl(&mc,&mb,&mt,&wc,&wb,&wt);
}
ivoid compute_running_alphas_rcl
      (const double q, const int nf, const int lp)
{
  __recola1_interface_rcl_MOD_compute_running_alphas_rcl(&q,&nf,&lp);
}
ivoid select_all_gs_powers_BornAmpl_rcl
      (const int npr)
{
  __recola1_interface_rcl_MOD_select_all_gs_powers_bornampl_rcl(&npr);
}
ivoid unselect_all_gs_powers_BornAmpl_rcl
      (const int npr)
{
  __recola1_interface_rcl_MOD_unselect_all_gs_powers_bornampl_rcl(&npr);
}
ivoid select_gs_power_BornAmpl_rcl
      (const int npr, const int gspower)
{
  __recola1_interface_rcl_MOD_select_gs_power_bornampl_rcl(&npr,&gspower);
}
ivoid unselect_gs_power_BornAmpl_rcl
      (const int npr, const int gspower)
{
  __recola1_interface_rcl_MOD_unselect_gs_power_bornampl_rcl(&npr,&gspower);
}
ivoid select_all_gs_powers_LoopAmpl_rcl
      (const int npr)
{
  __recola1_interface_rcl_MOD_select_all_gs_powers_loopampl_rcl(&npr);
}
ivoid unselect_all_gs_powers_LoopAmpl_rcl
      (const int npr)
{
  __recola1_interface_rcl_MOD_unselect_all_gs_powers_loopampl_rcl(&npr);
}
ivoid select_gs_power_LoopAmpl_rcl
      (const int npr, const int gspower)
{
  __recola1_interface_rcl_MOD_select_gs_power_loopampl_rcl(&npr,&gspower);
}
ivoid unselect_gs_power_LoopAmpl_rcl
      (const int npr, const int gspower)
{
  __recola1_interface_rcl_MOD_unselect_gs_power_loopampl_rcl(&npr,&gspower);
}
ivoid get_colour_correlation_r1_rcl
      (const int npr, 
       const int pow, 
       const int i1, const int i2, 
       double* A2cc)
{
  __recola1_interface_rcl_MOD_get_colour_correlation_r1_rcl(&npr,
                                                            &pow,
                                                            &i1,
                                                            &i2,
                                                            A2cc);
}
ivoid get_spin_colour_correlation_r1_rcl
      (const int npr, 
       const int pow, 
       const int i1, const int i2, 
       double* A2scc)
{
  __recola1_interface_rcl_MOD_get_spin_colour_correlation_r1_rcl(&npr,
                                                                 &pow,
                                                                 &i1,
                                                                 &i2,
                                                                 A2scc);
}
ivoid get_spin_correlation_r1_rcl
      (const int npr,
       const int pow,
       double* A2sc)
{
  __recola1_interface_rcl_MOD_get_spin_correlation_r1_rcl(&npr,
                                                          &pow,
                                                          A2sc);
}



/*******************************
*  module process definition  *
*******************************/

ivoid define_process_rcl
      (const int n,
       const char* proc,
       const char* order)
{
  __process_definition_rcl_MOD_define_process_rcl(&n,
                                                  proc,
                                                  order,
                                                  strlen(proc),
                                                  strlen(order));
}
ivoid select_power_bornampl_rcl
      (int n, const char* order, int power)
{
  __process_definition_rcl_MOD_select_power_bornampl_rcl(&n, order, &power, strlen(order));
}
ivoid unselect_power_bornampl_rcl
      (int n, const char* order, int power)
{
  __process_definition_rcl_MOD_unselect_power_bornampl_rcl(&n, order, &power, strlen(order));
}
ivoid select_all_powers_bornampl_rcl
      (const int n)
{
  __process_definition_rcl_MOD_select_all_powers_bornampl_rcl(&n);
}
ivoid unselect_all_powers_bornampl_rcl
      (const int n)
{
  __process_definition_rcl_MOD_unselect_all_powers_bornampl_rcl(&n);
}
ivoid select_power_loopampl_rcl
      (int n, const char* order, int power)
{
  __process_definition_rcl_MOD_select_power_loopampl_rcl(&n, order, &power, strlen(order));
}
ivoid unselect_power_loopampl_rcl
      (int n, const char* order, int power)
{
  __process_definition_rcl_MOD_unselect_power_loopampl_rcl(&n, order, &power, strlen(order));
}
ivoid select_all_powers_loopampl_rcl
      (int n)
{
  __process_definition_rcl_MOD_select_all_powers_loopampl_rcl(&n);
}
ivoid unselect_all_powers_loopampl_rcl
      (int n)
{
  __process_definition_rcl_MOD_unselect_all_powers_loopampl_rcl(&n);
}
ivoid split_collier_cache_rcl
      (const int npr,
       const int n)
{
  __process_definition_rcl_MOD_split_collier_cache_rcl(&npr,&n);
}

/*******************************
*  module process generation  *
*******************************/

ivoid generate_processes_rcl()
{
  __process_generation_rcl_MOD_generate_processes_rcl();
}

/************************************
*  module process_computation_rcl  *
************************************/

ivoid set_resonant_squared_momentum_rcl
      (const int npr,
       const int res,
       const double ps)
{
  __process_computation_rcl_MOD_set_resonant_squared_momentum_rcl(&npr,
                                                                  &res,
                                                                  &ps);
}
ivoid rescale_process_rcl
      (int npr,
       const char* order,
       double A2[2])
{
  __process_computation_rcl_MOD_rescale_process_rcl(&npr,
                                                    order,
                                                    A2,
                                                    strlen(order));
}
ivoid rescale_colour_correlation_rcl
      (const int npr, 
       const int i1, const int i2, 
       double* A2cc)
{
  __process_computation_rcl_MOD_rescale_colour_correlation_rcl(&npr,
                                                               &i1,
                                                               &i2,
                                                               A2cc);
}
ivoid rescale_all_colour_correlations_rcl
      (const int npr)
{
  __process_computation_rcl_MOD_rescale_all_colour_correlations_rcl(&npr);
}
ivoid rescale_spin_colour_correlation_rcl
      (const int npr, 
       const int i1, const int i2,  
       const dcomplex v[4], 
       double* A2scc)
{
  __process_computation_rcl_MOD_rescale_spin_colour_correlation_rcl(&npr,
                                                                    &i1,
                                                                    &i2,
                                                                    v,
                                                                    A2scc);
}
ivoid rescale_spin_correlation_rcl
      (const int npr, 
       const int j, 
       const dcomplex v[4], 
       double* A2sc)
{
  __process_computation_rcl_MOD_rescale_spin_correlation_rcl(&npr,
                                                             &j,
                                                             v,
                                                             A2sc);
}
ivoid set_tis_required_accuracy_rcl
      (const double acc)
{
  __process_computation_rcl_MOD_set_tis_required_accuracy_rcl(&acc);
}
ivoid get_tis_required_accuracy_rcl
      (double* acc)
{
  __process_computation_rcl_MOD_get_tis_required_accuracy_rcl(acc);
}
ivoid set_tis_critical_accuracy_rcl
      (const double acc)
{
  __process_computation_rcl_MOD_set_tis_critical_accuracy_rcl(&acc);
}
ivoid get_tis_critical_accuracy_rcl
      (double* acc)
{
  __process_computation_rcl_MOD_get_tis_critical_accuracy_rcl(acc);
}
ivoid get_tis_accuracy_flag_rcl
      (int* flag)
{
  __process_computation_rcl_MOD_get_tis_accuracy_flag_rcl(flag);
}

/************************
*  module wrapper_rcl  *
************************/

ivoid set_alphas_masses_nowidtharg_rcl
       (const double mc, const double mb, const double mt)
{
  __wrapper_rcl_MOD_set_alphas_masses_nowidtharg_rcl(&mc,&mb,&mt);
}
ivoid use_gfermi_scheme_rcl()
{
  __wrapper_rcl_MOD_use_gfermi_scheme_noarg_rcl();
}
ivoid use_gfermi_scheme_and_set_alpha_rcl
      (const double a)
{
  __wrapper_rcl_MOD_use_gfermi_scheme_and_set_alpha_rcl(&a);
}
ivoid use_gfermi_scheme_and_set_gfermi_rcl
      (const double g)
{
  __wrapper_rcl_MOD_use_gfermi_scheme_and_set_gfermi_rcl(&g);
}
ivoid use_alpha0_scheme_rcl()
{
  __wrapper_rcl_MOD_use_alpha0_scheme_noarg_rcl();
}
ivoid use_alphaz_scheme_rcl()
{
  __wrapper_rcl_MOD_use_alphaz_scheme_noarg_rcl();
}
ivoid set_gs_power_rcl
      (const int npr,
       int gsarray[][2],
       const int gslen)
{
   __wrapper_rcl_MOD_wrapper_set_gs_power_rcl(&npr,gsarray,&gslen);
}
ivoid set_outgoing_momenta_rcl
     (const int npr, double pIn[][4], double p[][4])
{

  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_set_outgoing_momenta_rcl(&npr, pIn, p, &legs);
}
ivoid compute_process_rcl
            (const int npr, 
             double p[][4],
             const char* order, 
             double A2[2], 
             int* momcheck)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_compute_process_rcl(&npr,
                                                p,
                                                &legs,
                                                order,
                                                A2,
                                                momcheck,
                                                strlen(order));
}
ivoid get_amplitude_r1_rcl(const int npr,
                           const int gspow,
                           const char* order,
                           int colour[],
                           int hel[],
                           dcomplex* A)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_get_amplitude_r1_rcl(&npr,
                                                 &gspow,
                                                 order,
                                                 colour,
                                                 hel,
                                                 &legs,
                                                 A,
                                                 strlen(order));
}
ivoid get_amplitude_general_rcl(const int npr,
                                int *pow,
                                const char* order,
                                int colour[],
                                int hel[],
                                dcomplex* A)
{

  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  int powlen;
  __wrapper_rcl_MOD_get_n_orders_rcl(&powlen);
  __wrapper_rcl_MOD_wrapper_get_amplitude_general_rcl(&npr,
                                                      pow,
                                                      &powlen,
                                                      order,
                                                      colour,
                                                      hel,
                                                      &legs,
                                                      A,
                                                      strlen(order));
}
ivoid get_squared_amplitude_r1_rcl
      (const int npr, 
       const int pow, 
       const char* order, 
       double* A2)
{
  __wrapper_rcl_MOD_wrapper_get_squared_amplitude_r1_rcl(&npr,
                                                         &pow,
                                                         order,
                                                         A2,
                                                         strlen(order));
}
ivoid get_squared_amplitude_general_rcl
            (const int npr, 
             const int pow[], 
             const char* order, 
             double* A2)
{
  int powlen;
  __wrapper_rcl_MOD_get_n_orders_rcl(&powlen);
  __wrapper_rcl_MOD_wrapper_get_squared_amplitude_general_rcl(&npr,
                                                              pow,
                                                              &powlen,
                                                              order,
                                                              A2,
                                                              strlen(order));
}
ivoid get_polarized_squared_amplitude_r1_rcl
      (const int npr, 
       const int pow, 
       const char* order,
       const int hel[], 
       double* A2h)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_get_polarized_squared_amplitude_r1_rcl(&npr,
                                                                   &pow,
                                                                   order,
                                                                   hel,
                                                                   &legs,
                                                                   A2h,
                                                                   strlen(order));
}
ivoid get_polarized_squared_amplitude_general_rcl
      (const int npr, 
       const int pow[], 
       const char* order,
       const int hel[], 
       double* A2h)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  int powlen;
  __wrapper_rcl_MOD_get_n_orders_rcl(&powlen);
  __wrapper_rcl_MOD_wrapper_get_polarized_squared_amplitude_general_rcl(&npr,
                                                                        pow,
                                                                        &powlen,
                                                                        order,
                                                                        hel,
                                                                        &legs,
                                                                        A2h,
                                                                        strlen(order));
}
ivoid compute_colour_correlation_rcl
      (const int npr, 
       double p[][4], 
       const int i1,
       const int i2, 
       double *A2cc,
       int* momcheck)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_compute_colour_correlation_rcl(&npr,
                                                           p,
                                                           &legs,
                                                           &i1,
                                                           &i2,
                                                           A2cc,
                                                           momcheck);
}
ivoid compute_all_colour_correlations_rcl
      (const int npr, 
       double p[][4], 
       int* momcheck)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_compute_all_colour_correlations_rcl(&npr,
                                                                p,
                                                                &legs,
                                                                momcheck);
}
ivoid get_colour_correlation_general_rcl
      (const int npr, 
       const int pow[], 
       const int i1, const int i2, 
       double* A2cc)
{

  int powlen;
  __wrapper_rcl_MOD_get_n_orders_rcl(&powlen);
  __wrapper_rcl_MOD_wrapper_get_colour_correlation_general_rcl(&npr,
                                                               pow,
                                                               &powlen,
                                                               &i1,
                                                               &i2,
                                                               A2cc);
}
ivoid compute_spin_colour_correlation_rcl
      (const int npr, 
       double p[][4], 
       const int i1, const int i2, 
       const dcomplex v[4], 
       double* A2scc,
       int* momcheck)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_compute_spin_colour_correlation_rcl(&npr,
                                                                p,
                                                                &legs,
                                                                &i1,
                                                                &i2,
                                                                v,
                                                                A2scc,
                                                                momcheck);
}
ivoid get_spin_colour_correlation_general_rcl
      (const int npr, 
       int pow[], 
       const int i1, const int i2, 
       double* A2scc)
{
  int powlen;
  __wrapper_rcl_MOD_get_n_orders_rcl(&powlen);
  __wrapper_rcl_MOD_wrapper_get_spin_colour_correlation_general_rcl(&npr,
                                                                    pow,
                                                                    &powlen,
                                                                    &i1,
                                                                    &i2,
                                                                    A2scc);
}
ivoid compute_spin_correlation_rcl
      (const int npr, 
       double p[][4],
       const int j, 
       const dcomplex v[4],
       double *A2sc,
       int* momcheck)
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_compute_spin_correlation_rcl(&npr,
                                                         p,
                                                         &legs,
                                                         &j,
                                                         v,
                                                         A2sc,
                                                         momcheck);
}
ivoid get_spin_correlation_general_rcl
      (const int npr,
       int pow[],
       double* A2sc)
{
  int powlen;
  __wrapper_rcl_MOD_get_n_orders_rcl(&powlen);
  __wrapper_rcl_MOD_wrapper_get_spin_correlation_general_rcl(&npr,
                                                             pow,
                                                             &powlen,
                                                             A2sc);
}
ivoid get_legs_rcl
      (const int npr, int *legs)
{
  __wrapper_rcl_MOD_get_legs_rcl(&npr, legs);
}
ivoid get_n_orders_rcl
      (int *n_orders)
{
  __wrapper_rcl_MOD_get_n_orders_rcl(n_orders);
}
ivoid get_momenta_rcl
      (const int npr,
       double p[][4])
{
  int legs;
  __wrapper_rcl_MOD_get_legs_rcl(&npr, &legs);
  __wrapper_rcl_MOD_wrapper_get_momenta_rcl(&npr,p,&legs);
}
ivoid get_recola_version_rcl
      (char recolaversion[][10])
{
  int  len;
  __wrapper_rcl_MOD_wrapper_get_recola_version_rcl(*recolaversion,&len,10);
}
ivoid get_modelname_rcl
      (char modelname[][100])
{
  int  len;
  __wrapper_rcl_MOD_wrapper_get_modelname_rcl(*modelname,&len,100);
}
ivoid get_modelgauge_rcl
      (char modelgauge[][100])
{
  int  len;
  __wrapper_rcl_MOD_wrapper_get_modelgauge_rcl(*modelgauge,&len,100);
}
ivoid get_driver_timestamp_rcl
      (char driverts[][200])
{
  int  len;
  __wrapper_rcl_MOD_wrapper_get_driver_timestamp_rcl(*driverts, &len,200);
}
ivoid get_renoscheme_rcl
      (const char paramname[], char renoscheme[][100])
{
  int  len;
  __wrapper_rcl_MOD_wrapper_get_renoscheme_rcl(paramname,
                                               *renoscheme,
                                               &len,
                                               strlen(paramname));
}

/*****************************************
*  module extended_higgs_interface_rcl  *
*****************************************/

ivoid set_Z2_thdm_yukawa_type_rcl
      (const int ytype)
{
  __extended_higgs_interface_rcl_MOD_set_z2_thdm_yukawa_type_rcl(&ytype);
}
ivoid set_pole_mass_hl_rcl
      (const double ml,
       const double gl)
{
  __extended_higgs_interface_rcl_MOD_set_pole_mass_hl_rcl(&ml,&gl);
}
ivoid set_pole_mass_hh_rcl
      (const double mh,
       const double gh)
{
  __extended_higgs_interface_rcl_MOD_set_pole_mass_hh_rcl(&mh,&gh);
}
ivoid set_pole_mass_hl_hh_rcl
      (const double ml,
       const double gl,
       const double mh,
       const double gh)
{
  __extended_higgs_interface_rcl_MOD_set_pole_mass_hl_hh_rcl(&ml,&gl,&mh,&gh);
}
ivoid set_pole_mass_ha_rcl
      (const double ma,
       const double ga)
{
  __extended_higgs_interface_rcl_MOD_set_pole_mass_ha_rcl(&ma,&ga);
}
ivoid set_pole_mass_hc_rcl
      (const double hc,
       const double gc)
{
  __extended_higgs_interface_rcl_MOD_set_pole_mass_hc_rcl(&hc,&gc);
}
ivoid set_tb_cab_rcl
      (const double tb,
       const double cab)
{
   __extended_higgs_interface_rcl_MOD_set_tb_cab_rcl(&tb,&cab);
}
ivoid use_mixing_alpha_msbar_scheme_rcl
      (const char* s)
{
   __extended_higgs_interface_rcl_MOD_use_mixing_alpha_msbar_scheme_rcl(s, strlen(s));
}
ivoid use_mixing_alpha_onshell_scheme_rcl
      (const char* s)
{
   __extended_higgs_interface_rcl_MOD_use_mixing_alpha_onshell_scheme_rcl(s, strlen(s));
}
ivoid use_mixing_beta_onshell_scheme_rcl
      (const char* s)
{
   __extended_higgs_interface_rcl_MOD_use_mixing_beta_onshell_scheme_rcl(s, strlen(s));
}
ivoid use_mixing_beta_msbar_scheme_rcl
      (const char* s)
{
   __extended_higgs_interface_rcl_MOD_use_mixing_beta_msbar_scheme_rcl(s, strlen(s));
}
ivoid set_msb_rcl
      (const double msb)
{
   __extended_higgs_interface_rcl_MOD_set_msb_rcl(&msb);
}
ivoid use_msb_msbar_scheme_rcl
      (const char* s)
{
   __extended_higgs_interface_rcl_MOD_use_msb_msbar_scheme_rcl(s, strlen(s));
}
ivoid set_sa_rcl
      (const double sa)
{
  __extended_higgs_interface_rcl_MOD_set_sa_rcl(&sa);
}
ivoid set_tb_rcl
      (const double tb)
{
  __extended_higgs_interface_rcl_MOD_set_tb_rcl(&tb);
}
ivoid use_tb_msbar_scheme_rcl
      (const char* s)
{
   __extended_higgs_interface_rcl_MOD_use_tb_msbar_scheme_rcl(s, strlen(s));
}

/***************************
*  module statistics_rcl  *
***************************/

ivoid print_generation_statistics_rcl
      ()
{
  __statistics_rcl_MOD_print_generation_statistics_rcl();
}
ivoid print_TI_statistics_rcl
      (const int npr, const int npoints)
{
  __statistics_rcl_MOD_print_ti_statistics_rcl(&npr, &npoints);
}
ivoid print_TC_statistics_rcl
      (const int npr, const int npoints)
{
  __statistics_rcl_MOD_print_tc_statistics_rcl(&npr, &npoints);
}

/**********************
*  module reset_rcl  *
**********************/

ivoid reset_recola_rcl()
{ 
  __reset_rcl_MOD_reset_recola_rcl();
}

#endif // RECOLA_H_
